



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++ 关联容器之map插入相同键元素与查找元素操作</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++ 关联容器之map插入相同键元素与查找元素操作</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 20:58:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一、插入相同键元素操作</h2>
<h3>（1）insert方法</h3>
<p>在map中的键必须是唯一的，当想map中连续插入键相同但值不同的元素时，编译和运行时都不会发生任何错误，系统会忽略后面的对已存在的键的插入操作，如</p>
<div>
<pre class="prettyprint linenums"> map&lt;int,int&gt; m1;<br />
 m1.insert(make_pair(,));<br />
 m1.insert(make_pair(,));<br />
 for(map&lt;int,int&gt;::iterator mit=m1.begin();mit!=m1.end();mit++){<br />
     cout&lt;&lt;mit-&gt;first&lt;&lt;":"&lt;&lt;mit-&gt;second&lt;&lt;endl;<br />
 }</pre>
</div>
<p>在第二行和第三行分别插入键都为1,但值不同的数据，此操作会忽略第三行的插入操作，其程序运行结果为：</p>
<div>
<pre class="prettyprint linenums">:</pre>
</div>
<p><strong>通过insert方法插入操作容易误解：</strong></p>
<p><strong>1. 认为插入相同键的操作会报错（正解：插入相同键的操作，无论是编译和运行时都不会报错）</strong></p>
<p><strong>2. 对插入相同键的数据时，后面的插入操作的值会覆盖前面的值，例如会误认为该例子中第三句的插入操作会使最终键为1的数据对应的值会被修改为3（正解：对于插入的数据的键值已存在，那么这个插入操作将会被忽略）</strong></p>
<h3>（2）通过下标操作</h3>
<p>向map中插入元素还可以用数组（关联数组）下标的方式，先看下面的例子</p>
<div>
<pre class="prettyprint linenums"> map&lt;int,int&gt; m1;<br />
 m1[]=;<br />
 m1[]=;<br />
 for(map&lt;int,int&gt;::iterator mit=m1.begin();mit!=m1.end();mit++){<br />
     cout&lt;&lt;mit-&gt;first&lt;&lt;":"&lt;&lt;mit-&gt;second&lt;&lt;endl;<br />
 }</pre>
</div>
<p>运行结果</p>
<div>
<pre class="prettyprint linenums">:</pre>
</div>
<p>这段代码与insert示例中的代码差别只在第2,3行，而从结果上看<strong>通过下标方式插入元素操作后面的赋值操作覆盖了前面的赋值操作</strong>。稍后会进一步对下标操作进行分析。</p>
<h2>二、查找并读取map中的元素</h2>
<p>map容器最大的优点就在于它可以快速定位并读取某一键值的元素。</p>
<h3>（1）通过下标查找</h3>
<p>如下代码所示</p>
<div>
<pre class="prettyprint linenums"> map&lt;string,int&gt; m1;<br />
 cout&lt;&lt;m1["abc"]&lt;&lt;endl;<br />
 m1["abc"]=;<br />
 cout&lt;&lt;m1["abc"]&lt;&lt;endl;</pre>
</div>
<p>运行结果：</p>
<div>
<pre class="prettyprint linenums">
</pre>
</div>
<p>由上面的代码可以看到，我们可以非常方便的通过数组下标的方式对map中的元素进行访问。但你可能对第2行的输出会有一些疑惑，因为最初map是空的，直接读取一个不存在的键，其居然会有正常的输出结果（可能并不是我们想要的），而之前我们并没有对该键进行任何赋值操作。</p>
<p><strong>解释下标索引的机制</strong></p>
<p><strong>用下标访问map中不存在的元素时，将导致向map中添加该下标所指向的新元素，其值会根据类型默认值或默认构造函数进行初始化（如int或初始化为0,string初始化为&ldquo;&rdquo;）。</strong></p>
<h3>（2）通过方法count()和find()查找</h3>
<p>因此，如果判断map中是否存在某键值的元素，一般不能通过取下标的方式判断，因为这样会想map中添加新元素。map标准库中提供了两种判断某键值的元素是否存在的方法，count()方法和find()方法，如下表</p>
<table>
<tbody>
<tr>
<td>map::count(k)</td>
<td>返回map中键k出现的次数，这里只能取0(不存在)和1(存在)</td>
</tr>
<tr>
<td>map::find(k)</td>
<td>如果容器中存在按k的索引元素，则返回指向该元素的迭代器。如果不存在则返回超出末端的迭代器</td>
</tr>
</tbody>
</table>
<p>这两种方法不会向map中插入新元素，因此对map索引键判断时，应选用这两种方法。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z17gn9.html">【bzoj4518】 Sdoi2016&mdash;征途</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r0pre9.html">Fortran版MPI&lowbar;barrier出现错误可能情况</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j2g3l8.html">强制span不换行</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnyz5x8.html">javascript&mdash;&mdash;Array</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96njy4q.html">看好你的门-客户端传数据-用java修改referer</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdmn1zq.html">BZOJ4320 &colon; ShangHai2006 Homework</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k3vv3q.html">Heterogeneous System Architecture</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeooz09.html">【Java&sol;Android性能优化1】Android性能调优</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okyd659.html">查看系统或者Jmeter的Properties</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdex3xj9.html">10&lowbar;控制线程&lowbar;线程让步yield</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmg05k9.html">UIView--UIImageView</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wroroq.html">使用jQuery出现the function undefined</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zokeznq.html">【卷二】网络二&mdash;TCP服务器与客户端</a>
		</li>
						<li><a href="https://www.batexi.com/a/950pr0e8.html">digitalocean vpn安装配置教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzvl7l8.html">避免subList／subString陷阱</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj02528.html">Logger之Logger&period;getLogger&lpar;CLass&rpar;技巧代替system&period;out&period;print</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m5lm48.html">Swift基础之侧滑Cell显示操作按钮</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gew7g08.html">&lpar;双指针&rpar; leetcode 485&period; Max Consecutive Ones</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4y75e9.html">&lbrack;Spring实战笔记&rsqb;4面向切面编程的Spring-代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj3z279.html">vscode实现vue&period;js项目的过程</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93yy56z8.html">十天学Linux内核之第一天---内核探索工具类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv11gwyq.html">DDD实践案例：引入事件驱动与中间件机制来实现后台管理功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pp6e48.html">React实践（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1yyddq.html">数据结构与算法之递推算法 C&plus;&plus;与PHP实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zjjr59.html">【&period;NET特供-第三季】ASP&period;NET MVC系列：MVC与三层图形对照</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoykjxq.html">mysqldump报错</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1krv049.html">linq 分组求和</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kr5k29.html">HDU 1385 Minimum Transport Cost 最短路径题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljlo1e9.html">Web API 2：Action的返回类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv12z01q.html">C语言库函数大全及应用实例十三</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
